﻿


local moroDebug = false

local x = 7
local y = -6

local frameHeight = 28
local frameWidth = 74

local rowspercol = 10

local borderwidth = 3
local spacing =			{ vertical = 10,	horizontal = 10 }
local mouseinsets =		{ left = 5,		right = 5,		top = 5,	bottom = 5 }
local nameoffset =		{ left = 1,		right = 0,		top = -2,	bottom = 1 }

local hptexture = "Interface\\TargetingFrame\\UI-StatusBar"
local predicttexture = "Interface\\TargetingFrame\\UI-StatusBar"
local bordertexture = "Interface\\AddOns\\MoroRaidUI\\Back"
local backtexture = "Interface\\AddOns\\MoroRaidUI\\Back"

local fontsize = 7
local fontstyle = "Fonts\\FRIZQT__.TTF"
local justifyh = "LEFT"
local justifyv = "BOTTOM"
local xshadowoffset = 1
local yshadowoffset = -1

local hpcol =			{ r = 0,		g = 0.85,		b = 0 }
local predictcol =		{ r = 0.5,		g = 0.75,		b = 0.9 }
local namecol =			{ r = 1,		g = 1,			b = 1, 		a = 1 }
local backcol =			{ r = 0,		g = 0,			b = 0,		a = 0.5 }
local bordercol = {}
bordercol["None"] =		{ r = 0,		g = 0,			b = 0,		a = 0.8 }
bordercol["Magic"] =	{ r = 0,		g = 0.6,		b = 1,		a = 0.8 }
bordercol["Curse"] =	{ r = 0.8,		g = 0,			b = 1,		a = 0.8 }
bordercol["Disease"] =	{ r = 0.8,		g = 0.3,		b = 0,		a = 0.8 }
bordercol["Poison"] =	{ r = 0,		g = 0.9,		b = 0,		a = 0.8 }

local hppredict = true
local predictmulti = 3
local showdispelborder = true
local showfullhpdispels = false
local forceshowposion = false
local forceshowdisease = false
local forceshowmagic = false
local forceshowcurse = false
local compactmgralpha = 1
local visthreshold = 90
local showalpha = 1
local hidealpha = 0
local outofrangealpha = 0.4
local outofrangeholdtime = 10
local hideself = false
local hiderealm = true
local hiderealmprefix = ""
local hiderealmsuffix = "*"



local raid = {}
local debuff = {}
local vis = {}
local alpha = {}
local hp = {}
local hpmax = {}
local hpthresh = {}

local scale = GetScreenHeight() / strmatch(({GetScreenResolutions()})[GetCurrentResolution()], "%d+x(%d+)")
--local xscale = GetScreenWidth() / strmatch(({GetScreenResolutions()})[GetCurrentResolution()], "(%d+)x%d+")
local player = UnitName("player")
local inraid = false
local dispel = ""
local excluded = ""
if borderwidth <= 0 then
	bordertexture = nil
	showdispelborder = false
	borderwidth = 0
end
local moroBG = {
	bgFile = backtexture,
	edgeFile = bordertexture,
	tile = true,
	tileSize = 16,
	edgeSize = borderwidth * scale,
	insets = {
		left = borderwidth * scale,
		right = borderwidth * scale,
		top = borderwidth * scale,
		bottom = borderwidth * scale
	}
}



CompactRaidFrameManager:SetAlpha(compactmgralpha)
raidParentMoroFrame = CreateFrame("Frame", raidParentMoroFrame)
raidParentMoroFrame:SetFrameStrata("LOW")

local rows = 0

for i = 1,40 do
	local unit = "raid"..i
	local frame = unit.."MoroFrame"
	local back = unit.."MoroBack"
	local hp = unit.."MoroHPBar"
	local predict = unit.."MoroPredictBar"
	local name = unit.."MoroName"

	frame = CreateFrame("Button", frame, raidParentMoroFrame, "SecureUnitButtonTemplate")
	frame:SetFrameLevel(0)
	frame:SetAttribute("unit", unit)
	frame:SetAttribute("type", "target")
	frame:SetHeight(frameHeight * scale)
	frame:SetWidth(frameWidth * scale)
	frame:SetHitRectInsets(-mouseinsets.left, -mouseinsets.right, -mouseinsets.top, -mouseinsets.bottom)
	frame:SetAlpha(hidealpha)
	if i == 1 then
		frame:SetPoint("TOPLEFT", CompactRaidFrameManager, "TOPRIGHT", x * scale, y * scale)
	elseif rows == rowspercol then
		local last = i - rows
		rows = 0
		frame:SetPoint("TOPLEFT", "raid"..last.."MoroFrame", "TOPRIGHT", spacing.horizontal * scale, 0)
	else
		local last = i - 1
		frame:SetPoint("TOPLEFT", "raid"..last.."MoroFrame", "BOTTOMLEFT", 0, -spacing.vertical * scale)
	end
	rows = rows + 1

	back = CreateFrame("Frame", back, frame)
	back:SetFrameLevel(1)
	back:SetPoint("TOPLEFT", frame, "TOPLEFT")
	back:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT")

	back:SetBackdrop(moroBG)
	local col = bordercol["None"]
	back:SetBackdropBorderColor(col.r, col.g, col.b, col.a)
	back:SetBackdropColor(backcol.r, backcol.g, backcol.b, backcol.a)

	hp = CreateFrame("StatusBar", hp, frame)
	hp:SetFrameLevel(3)
	hp:SetStatusBarTexture(hptexture)
	hp:GetStatusBarTexture():SetHorizTile(false)
	hp:GetStatusBarTexture():SetVertTile(false)
	hp:SetStatusBarColor(hpcol.r, hpcol.g, hpcol.b)
	hp:SetPoint("TOPLEFT", back, "TOPLEFT", borderwidth * scale, -borderwidth * scale)
	hp:SetPoint("BOTTOMRIGHT", back, "BOTTOMRIGHT", -borderwidth * scale, borderwidth * scale)

	if hppredict then
		predict = CreateFrame("StatusBar", predict, frame)
		predict:SetFrameLevel(2)
		predict:SetStatusBarTexture(predicttexture)
		predict:GetStatusBarTexture():SetHorizTile(false)
		predict:GetStatusBarTexture():SetVertTile(false)
		predict:SetStatusBarColor(predictcol.r, predictcol.g, predictcol.b)
		predict:SetAllPoints(hp)
	end

	name = hp:CreateFontString(name, "ARTWORK")
	name:SetFont(fontstyle, fontsize)
	name:SetTextColor(namecol.r, namecol.g, namecol.b, namecol.a)
	name:SetJustifyH(justifyh)
	name:SetJustifyV(justifyv)
	name:SetShadowOffset(xshadowoffset, yshadowoffset)
	name:SetText("Placeholder\nText")
	name:SetPoint("TOPLEFT", hp, "TOPLEFT", nameoffset.left * scale, nameoffset.top * scale)
	name:SetPoint("BOTTOMRIGHT", hp, "BOTTOMRIGHT", nameoffset.right * scale, nameoffset.bottom * scale)

	frame:RegisterUnitEvent("UNIT_MAXHEALTH", unit)
	frame:RegisterUnitEvent("UNIT_HEALTH", unit)
	if hppredict then
		frame:RegisterUnitEvent("UNIT_HEAL_PREDICTION", unit)
	end
	if showdispelborder then
		frame:RegisterUnitEvent("UNIT_AURA", unit)
	end

	frame:SetScript("OnEvent", function(_, event, u)
		if event == "UNIT_AURA" then
			moroUpdateRaidAura(u)
		elseif event == "UNIT_MAXHEALTH" then
			moroUpdateRaidMaxHP(u)
		elseif event == "UNIT_HEALTH" then
			moroUpdateRaidHP(u)
		elseif event == "UNIT_HEAL_PREDICTION" then
			moroUpdateRaidPredict(u)
		end
	end)

end



function moroCheckDispel()

	dispel = ""

	local class = UnitClass("player")

	if class == "Paladin" then
		local cleanse = IsSpellKnown(4987)
		if cleanse then
			dispel = dispel.."Posion"
			dispel = dispel.."Disease"
			local _, spec = GetSpecializationInfo( GetSpecialization() )
			if spec == "Holy" then
				dispel = dispel.."Magic"
			end
		end

	elseif class == "Shaman" then
		local cleanse = IsSpellKnown(51886)
		if cleanse then
			dispel = dispel.."Curse"
			local _, spec = GetSpecializationInfo( GetSpecialization() )
			if spec == "Restoration" then
				dispel = dispel.."Magic"
			end
		end

	elseif class == "Monk" then
		local detox = IsSpellKnown(115450)
		if detox then
			dispel = dispel.."Posion"
			dispel = dispel.."Disease"
			local _, spec = GetSpecializationInfo( GetSpecialization() )
			if spec == "Mistweaver" then
				dispel = dispel.."Magic"
			end
		end

	elseif class == "Priest" then
		local purify = IsSpellKnown(527)
		if purify then
			dispel = dispel.."Disease"
			dispel = dispel.."Magic"
		end

	elseif class == "Druid" then
		local decorrupt = IsSpellKnown(2782)
		if decorrupt then
			dispel = dispel.."Posion"
			dispel = dispel.."Curse"
			local adv = IsSpellKnown(88423)
			if adv then
				dispel = dispel.."Magic"
			end
		end

	elseif class == "Mage" then
		local magedecurse = IsSpellKnown(475)
		if magedecurse then
			dispel = dispel.."Curse"
		end
	end

	if forceshowposion then
		dispel = dispel.."Posion"
	end

	if forceshowdisease then
		dispel = dispel.."Disease"
	end

	if forceshowmagic then
		dispel = dispel.."Magic"
	end

	if forceshowcurse then
		dispel = dispel.."Curse"
	end

	moroUpdateAllRaidAuras()

end



function moroCheckRaidParentVis()

	if inraid then
		raidParentMoroFrame:Show()
	else
		raidParentMoroFrame:Hide()
	end

end



function moroUpdateAllRaidFrames()

	if UnitInRaid("player") then

		inraid = true

		for i = 1, 40 do
			local unit = "raid"..i
			local name, _,_,_,_,_,_, online = GetRaidRosterInfo(i)

			if name and online then
				moroUpdateRaidName(unit, name)
				moroUpdateRaidMaxHP(unit)
				if showdispelborder then
					moroUpdateRaidAura(unit)
				end
			else
				raid[unit] = false
			end
		end

	else
		inraid = false
	end

	local combat = UnitAffectingCombat("player")
	if not combat then
		moroCheckRaidParentVis()
	end

end



function moroUpdateAllRaidAuras()

	if UnitInRaid("player") then
		for i = 1, 40 do
			local unit = "raid"..i
			local name, _,_,_,_,_,_, online = GetRaidRosterInfo(i)

			if name and online then
				if showdispelborder then
					moroUpdateRaidAura(unit)
				end
			else
				raid[unit] = false
			end
		end
	end

end



function moroUpdateRaidAura(unit)

	for i = 1, 40 do
		local name, _,_,_, dtype = UnitDebuff(unit, i, 1)

		if name then

			if dtype and strmatch(dispel, dtype) then
				if debuff[unit] then
					if debuff[unit] ~= dtype then
						debuff[unit] = dtype
						moroUpdateRaidColour(unit, dtype)
					end
				else
					debuff[unit] = dtype
					moroUpdateRaidColour(unit, dtype)
				end
				break
			end

		else
			if debuff[unit] then
				debuff[unit] = false
				moroUpdateRaidColour(unit)
			end
			break
		end

	end
end



function moroUpdateRaidColour(unit, dtype)

	local col
	if dtype then
		col = bordercol[dtype]
	else
		col = bordercol["None"]
	end
	_G[unit.."MoroBack"]:SetBackdropBorderColor(col.r, col.g, col.b, col.a)

end



function moroUpdateRaidName(unit, name)

	if hideself and name == player then
		excluded = unit
	end
	if hiderealm then
		local n = UnitName(unit)
		if n and n ~= name then
			name = hiderealmprefix..n..hiderealmsuffix
		end
	end
	_G[unit.."MoroName"]:SetText(name)

end



function moroUpdateRaidMaxHP(unit)

	hpmax[unit] = UnitHealthMax(unit)
	hpthresh[unit] = hpmax[unit] / 100 * visthreshold
	_G[unit.."MoroHPBar"]:SetMinMaxValues(0, hpmax[unit])
	_G[unit.."MoroPredictBar"]:SetMinMaxValues(0, hpmax[unit])
	moroUpdateRaidHP(unit)
	if hppredict then
		moroUpdateRaidPredict(unit)
	end

end



function moroUpdateRaidHP(unit)

	hp[unit] = UnitHealth(unit)
	if hpthresh[unit] and hp[unit] < hpthresh[unit] and unit ~= excluded then
		raid[unit] = true
	else
		raid[unit] = false
	end
	_G[unit.."MoroHPBar"]:SetValue(hp[unit])
	moroUpdateRaidPredict(unit)

end



function moroUpdateRaidPredict(unit)

	if hp[unit] then
		local incoming = UnitGetIncomingHeals(unit) or 0
		incoming = ( incoming * predictmulti ) + hp[unit]
		if hpmax[unit] and incoming > hpmax[unit] then
			incoming = hpmax[unit]
		end
		_G[unit.."MoroPredictBar"]:SetValue(incoming)
	end

end



local update = CreateFrame("Frame")
update:SetScript("OnUpdate", function(_, elapsed)

	if UnitInRaid("player") then
		for i = 1, 40 do
			local unit = "raid"..i

			if vis[unit] then
				if raid[unit] or (showfullhpdispels and debuff[unit]) then
					if alpha[unit] then
						if UnitInRange(unit) then
							alpha[unit] = nil
							_G[unit.."MoroFrame"]:SetAlpha(showalpha)
						elseif alpha[unit] > 0 then
							alpha[unit] = alpha[unit] - elapsed
						else
							alpha[unit] = nil
							vis[unit] = false
							_G[unit.."MoroFrame"]:SetAlpha(hidealpha)
						end
					else
						if not UnitInRange(unit) then
							alpha[unit] = outofrangeholdtime
							_G[unit.."MoroFrame"]:SetAlpha(outofrangealpha)
						end
					end
				else
					alpha[unit] = nil
					vis[unit] = false
					_G[unit.."MoroFrame"]:SetAlpha(hidealpha)
				end
			else
				if ( raid[unit] or (showfullhpdispels and debuff[unit]) ) and UnitInRange(unit) then
					vis[unit] = true
					_G[unit.."MoroFrame"]:SetAlpha(showalpha)
				end
			end

		end
	end

end)



local event1 = CreateFrame("Frame")
event1:RegisterEvent("GROUP_ROSTER_UPDATE")
event1:RegisterEvent("PLAYER_ENTERING_WORLD")

event1:SetScript("OnEvent", function()
	moroUpdateAllRaidFrames()
end)



local event2 = CreateFrame("Frame")
event2:RegisterEvent("PLAYER_REGEN_ENABLED")

event2:SetScript("OnEvent", function()
	moroCheckRaidParentVis()
end)



local event3 = CreateFrame("Frame")
event3:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
event3:RegisterEvent("PLAYER_ENTERING_WORLD")

event3:SetScript("OnEvent", function()
	moroCheckDispel()
end)



if moroDebug then
	print("hello world")
	print("debugs?")
	update:SetScript("OnUpdate", nil)
	event1:SetScript("OnEvent", nil)
	event2:SetScript("OnEvent", nil)
	event3:SetScript("OnEvent", nil)
	raidParentMoroFrame:Show()
	local count = 0
	local rh
	local rp
	for i = 1, 40 do
		local unit = "raid"..i
		_G[unit.."MoroFrame"]:SetAlpha(1)
		if count < 20 then
			count = count + 1
			rh = random(100)
			_G[unit.."MoroHPBar"]:SetMinMaxValues(0, 100)
			_G[unit.."MoroHPBar"]:SetValue(rh)
			if hppredict then
				rp = random(rh, 100)
				_G[unit.."MoroPredictBar"]:SetMinMaxValues(0, 100)
				_G[unit.."MoroPredictBar"]:SetValue(rp)
			end
			if showdispelborder then
				if count == 1 or count == 11 then
					col = bordercol["Magic"]
					_G[unit.."MoroBack"]:SetBackdropBorderColor(col.r, col.g, col.b, col.a)
				elseif count == 2 or count == 12 then
					col = bordercol["Curse"]
					_G[unit.."MoroBack"]:SetBackdropBorderColor(col.r, col.g, col.b, col.a)
				elseif count == 3 or count == 13 then
					col = bordercol["Disease"]
					_G[unit.."MoroBack"]:SetBackdropBorderColor(col.r, col.g, col.b, col.a)
				elseif count == 4 or count == 14 then
					col = bordercol["Poison"]
					_G[unit.."MoroBack"]:SetBackdropBorderColor(col.r, col.g, col.b, col.a)
				end
			end
		else
			_G[unit.."MoroHPBar"]:SetMinMaxValues(0, 100)
			_G[unit.."MoroHPBar"]:SetValue(100)
		end
	end
end


